//----------------------------------------------------------------------
/*EASTRISING TECHNOLOGY CO,.LTD.*/
// Module    : TFT-ER035-1  320*240 3.5"
// Lanuage   : C51 Code
// Create    : JAVEN
// Date      : Apr-1-2013
// Drive IC  : SSD2119
// INTERFACE : 8080_8bit OR 16bit
// MCU       : STC12LE5A60S2
// VDD	      : 2.8V      
//----------------------------------------------------------------------
//======================================================================================

#include <STC12C5A.h>
#include <stdio.h>
#include <intrins.h>
#include<2119TP.h>
#include<word.h>
#include<TP.h>
//=============================================================
//SDҪ4ź
sbit SD_CLK = P1^7;
sbit SD_DI  = P1^5;
sbit SD_DO  = P1^6;
sbit SD_CS  = P1^4;
//===========================================================

//===========================================================
//512ֽڻעҪʹ xdataؼ
unsigned char xdata DATA[512];

//===========================================================
//дһֽڵSD,ģSPI߷ʽ
void SdWrite(unsigned char n)
{

unsigned char i;

for(i=8;i;i--)
{
SD_CLK=0;
SD_DI=(n&0x80);
n<<=1;
SD_CLK=1;
}
SD_DI=1; 
} 
//===========================================================
//SDһֽ,ģSPI߷ʽ
unsigned char SdRead()
{
unsigned char n,i;
for(i=8;i;i--)
{
SD_CLK=0;
SD_CLK=1;
n<<=1;
if(SD_DO) n|=1;

}
return n;
}
//============================================================
//SDӦ
unsigned char SdResponse()
{
unsigned char i=0,response;

while(i<=8)
{
response = SdRead();
if(response==0x00)
break;
if(response==0x01)
break;
i++;
}
return response;
} 
//================================================================
//SD
void SdCommand(unsigned char command, unsigned long argument, unsigned char CRC)
{

SdWrite(command|0x40);
SdWrite(((unsigned char *)&argument)[0]);
SdWrite(((unsigned char *)&argument)[1]);
SdWrite(((unsigned char *)&argument)[2]);
SdWrite(((unsigned char *)&argument)[3]);
SdWrite(CRC);
}
//================================================================
//ʼSD
unsigned char SdInit(void)
{
int delay=0, trials=0;
unsigned char i;
unsigned char response=0x01;

SD_CS=1;
for(i=0;i<=9;i++)
SdWrite(0xff);
SD_CS=0;

//Send Command 0 to put MMC in SPI mode
SdCommand(0x00,0,0x95);


response=SdResponse();

if(response!=0x01)
{
return 0;
} 

while(response==0x01)
{
SD_CS=1;
SdWrite(0xff);
SD_CS=0;
SdCommand(0x01,0x00ffc000,0xff);
response=SdResponse();
} 

SD_CS=1;
SdWrite(0xff);
return 1; 
}
//================================================================
//SDַָд,һ512ֽ
unsigned char SdWriteBlock(unsigned char *Block, unsigned long address,int len)
{
unsigned int count;
unsigned char dataResp;
//Block size is 512 bytes exactly
//First Lower SS

SD_CS=0;
//Then send write command
SdCommand(0x18,address,0xff);

if(SdResponse()==00)
{
SdWrite(0xff);
SdWrite(0xff);
SdWrite(0xff);
//command was a success - now send data
//start with DATA TOKEN = 0xFE
SdWrite(0xfe);
//now send data
for(count=0;count<len;count++) SdWrite(*Block++);

for(;count<512;count++) SdWrite(0);
//data block sent - now send checksum
SdWrite(0xff); //ֽCRCУ, Ϊ0XFFFF ʾCRC
SdWrite(0xff);
//Now read in the DATA RESPONSE token
dataResp=SdRead();
//Following the DATA RESPONSE token
//are a number of BUSY bytes
//a zero byte indicates the MMC is busy

while(SdRead()==0);

dataResp=dataResp&0x0f; //mask the high byte of the DATA RESPONSE token
SD_CS=1;
SdWrite(0xff);
if(dataResp==0x0b)
{
//printf("DATA WAS NOT ACCEPTED BY CARD -- CRC ERROR\n");
return 0;
}
if(dataResp==0x05)
return 1;

//printf("Invalid data Response token.\n");
return 0;
}
//printf("Command 0x18 (Write) was not received by the MMC.\n");
return 0;
}

//=======================================================================
//SDַָȡ,һ512ֽ
unsigned char SdReadBlock(unsigned char *Block, unsigned long address,int len)
{
unsigned int count;
//Block size is 512 bytes exactly
//First Lower SS

 //printf("MMC_read_block\n");

SD_CS=0;
//Then send write command
SdCommand(0x11,address,0xff);

if(SdResponse()==00)
{
//command was a success - now send data
//start with DATA TOKEN = 0xFE
while(SdRead()!=0xfe);

for(count=0;count<len;count++) *Block++=SdRead(); 

for(;count<512;count++) SdRead();

//data block sent - now send checksum
SdRead();
SdRead();
//Now read in the DATA RESPONSE token
SD_CS=1;
SdRead();
return 1;
}
 //printf("Command 0x11 (Read) was not received by the MMC.\n");
return 0;
}

//============================================================
//	
main()
{unsigned f;
// unsigned int x,y; //Һ
 unsigned long j;  //ִѭҪʱ
  unsigned int i;
  unsigned long AddTemp;//SDַһַʼֵwinhex鿴512512x512=262144ʵSDݸ
 	P1=0xff;
 	P2=0xff;
 	P3=0xff;
 	P0=0xff;

	SSD2119_Initial();//Һʼ

	TPTEST();

	DispRGBGray();
     while(KEY); 


	LCD_FULL(0xf800);
     while(KEY); 	    
	LCD_FULL(0x07e0);
     while(KEY); 	 	
	LCD_FULL(0x001f);
     while(KEY); 
	LCD_FULL(0x07ff);
     while(KEY); 
	LCD_FULL(0xffe0);
     while(KEY); 
	LCD_FULL(0xf81f);
     while(KEY); 

 	ClearScreen(0x00);	//ȫ
     while(KEY); 
 	ClearScreen(0xffff);	//ȫ
     while(KEY); 


	SdInit();         //SDʼ
	f=10;
	AddTemp=328192;

 while(f--)
 {	
 
//  if(f%2!=0)
 //	{ 
	Write_Cmd_Data(0x0011,0x6218);  	//   Vertical screen mode     240*320   65k colour
  	   LCD_SetPos(0,239); 
//	}
//	 else
 //	{ Write_Cmd_Data(0x0011,0x6270);    //6270 Entry Mode   Horizontal screen mode   320*240    65k colour
 // 	   LCD_SetPos(0,0); 
//	}
	  


 for(j=0;j<300;j++)   //300ʾһͼƬ300x512ֽڵϢ
    {
    SdReadBlock(DATA,AddTemp+(j*512),512);//ÿζ512ֽڷŵ
    for(i=0;i<256;i++)                    //ȻдҺʾ256أÿ16λ2ֽ
	   {   
//  	   LCD_SetPos(xa,xa,ya,ya);
   	   Write_Data(DATA[2*i],DATA[2*i+1]);	 
//	   xa++;
//	   if(xa==240)                         //ǷдıԵ 240x320
//	     {
//	     ya++;
//	     xa=0;
//	     if(ya==320)
//	       ya=0;
//	     }
       }
     } 
     AddTemp = AddTemp+((j+20)*512);          //дһͼƬSDַ300x512һͼƬַ
     while(KEY);                         //ȴ¼ִѭʾһͼƬûаȴ
	 
 } 
}



